SystemOrganization addCategory: #'Glamour-Test-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

GLMMorphicTest subclass: #GLMCompositePresentationMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMCompositePresentationMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 1/10/2010 08:38'!
testAccordion
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; showing: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = ExpanderMorph.
	self assert: compositeMorph submorphs last class = ExpanderMorph.
	self assert: compositeMorph class = PanelMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 1/10/2010 08:38'!
testStackedVertically
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; showing: [ :a | 
		a stackedVerticallyArrangement.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class == PanelMorph.
	self assert: compositeMorph submorphs first class == GroupboxMorph.! !

!GLMCompositePresentationMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 1/10/2010 08:37'!
testTabs
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; showing: [ :a | 
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class == LazyTabGroupMorph.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 12/30/2009 16:35'!
expectedFailures
	^ #(testChildrenBlock testChildrenBlockTakesEntity testColumnBlockTakesEntity)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/17/2009 07:39'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 0.5 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:42'!
send: treeMorph doubleClickWithShift: aBoolean onItem: treeNodeMorph
	| event |
	event:= MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph doubleClick: event! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:39'!
send: treeMorph mouseDownWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/19/2009 11:39'!
send: treeMorph mouseUpOnItem: treeNodeMorph
	^ self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/29/2009 02:38'!
send: treeMorph mouseUpWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'setup - tear down' stamp: 'tg 1/9/2010 22:12'!
tearDown
	window ifNotNil: [window delete]! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testAllowNil
	| browser presentationsChanged detailsMorph |
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree display: #(1 2 3)].
	browser showOn: #two; using: [
		browser tree display: #(a b c)].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #selection) value: 2.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2nil'.
	((browser paneNamed: #two) port: #selection) value: #c.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2c'.
	((browser paneNamed: #one) port: #selection) value: nil.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = 'nilc'.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:12'!
testChildrenBlock

	| browser check treeMorph mouseUp treeNodeMorph |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self repeatAssert: [check] equals: true! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testChildrenBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testColumnBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x'].
	window := browser openOn: (1 to: 5).
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/11/2010 02:22'!
testInterdependentPanesShouldUpdateTheFocusTriggerPane
	|browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x*2]].
	browser showOn: #three; from: #two; using: [
		browser list
			display: [:x | 1 to: x*3];
			update: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
	browser sendTo: #outer->#focus from: #three->#focus.
	browser sendTo: #one->#selection from: #outer->#focus with: [:x | x + 1].
	browser sendTo: #two->#selection from: #outer->#focus with: [:x | x + 2].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	((browser paneNamed: #three) port: #selection) value: 12.
	((browser paneNamed: #three) port: #focus) value: 12.
	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testListDoubleClick

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value = $a.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testListDoubleClickWithMultipleSelection

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value asSet = ($a to: $d) asSet.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testMultipleInitialSelection
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	window := browser openOn: 5.
	(browser panes first port: #selection) value: #(2 5 3).
	firstTreeMorph := window submorphs last submorphs second submorphs first submorphs first.
	secondTreeMorph := window submorphs last submorphs last submorphs first submorphs first.
	self assert: firstTreeMorph model selection notNil.
	self assert: firstTreeMorph model selection selectedItemOrItemsOrNil size = 3.
	self assert: secondTreeMorph model selection isNil.
	self assert: (secondTreeMorph model roots collect: #item) = firstTreeMorph model selection selectedItemOrItemsOrNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testNoSelection
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree noSelection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: browser panes size = 1! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testSpawnFinder
	| browser check |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testSpawnTableLayoutBrowser

	| browser check |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeAllowDeseletion
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |	
	browser := GLMFinder new.
	browser list allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeDefaultAllowDeseletion
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeMultipleSelection
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (browser panes first port: #selection) value notNil.
	self assert: (browser panes first port: #selection) value asSet = ($a to: $d) asSet! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeMultipleSelectionWithCancellation

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeSelection

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeSelectionCancellation

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeWithDisplay
	| browser treeCollection |
	treeCollection := { #root1->{#child1->{} . #child2->{}} . #root2 ->{} }.
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			display: [:each | each value ];
			children: [:x | x value ] ].
	window := browser openOn: #something -> treeCollection.
	self assert: browser panes first presentations first displayValue == treeCollection! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 1/6/2010 00:36'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time millisecondClockValue // 1000.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !

GLMMorphicTest subclass: #GLMTreeMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/10/2010 23:05'!
testMultipleSelectionWithChange
	| browser firstTreeMorph secondTreeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; showing: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := firstTreeMorph scroller submorphs first.
	lastTreeNodeMorph := firstTreeMorph scroller submorphs last.
	self send: firstTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: firstTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (firstTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(2 3 4) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := secondTreeMorph scroller submorphs first.
	lastTreeNodeMorph := secondTreeMorph scroller submorphs second.
	self send: secondTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: secondTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (secondTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(40 41) asOrderedCollection.! !

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/10/2010 22:59'!
testMultipleSelectionWithChangeFromModel
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; showing: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (firstTreeMorph model roots collect: #item) = #(2 3 4).
	((browser paneNamed: #one) port: #selection) value: #(2 3).
	self assert: ((browser paneNamed: #one) port: #selection) value = #(2 3) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (secondTreeMorph model roots collect: #item)= #(40 41 42).
	((browser paneNamed: #one) port: #selection) value: #(40 41).
	self assert: ((browser paneNamed: #one) port: #selection) value = #(40 41) asOrderedCollection.

	self assert: firstTreeMorph ~= secondTreeMorph! !

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/10/2010 23:46'!
testTwoPanesMultipleSelectionWithChange
	| browser treeMorphOne treeNodeMorph treeMorphTwo |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #one; showing: [:a |
		a list display: [:x | 1 to: x ]].
	browser transmit to: #two; from: #one; showing: [:a |
		a list beMultiple; display: [:x | (x * 10) to: (x * 10 + 4) ] ].
	browser transmit to: #three; from: #two; showing: [:a | a text ].
	window := browser openOn: 4.

	"we select 2 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs second.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select all in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(20 21) asOrderedCollection.
	
	"we select 4 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs last.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select the first two in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	self assert: (treeMorphTwo model roots collect: #item) = #(40 41 42 43 44).
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(40 41) asOrderedCollection ! !

GLMMorphicTest subclass: #GLMUpdateMorphicTest
	instanceVariableNames: 'announcer entity browser treeMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 1/5/2010 21:42'!
expectedFailures
	^ #(testInvalidateSelection)! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 12/31/2009 03:59'!
setUp
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list 
			updateYourselfOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true ].
	browser showOn: #two; from: #one; using: [browser text].
	window := browser openOn: entity.
	treeMorph := window submorphs last submorphs second submorphs first submorphs first.
! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 12/31/2009 03:59'!
testAdd
	entity add: 4.
	announcer announce: TestAnnouncement.
	self assert: treeMorph model roots size = 4! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 12/31/2009 04:02'!
testInvalidateSelection
	(browser panes first port: #selection) value: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: (browser panes first port: #selection) value isNil.
	self assert: treeMorph model selection selectedItemOrItemsOrNil isNil! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 12/31/2009 03:59'!
testRemove
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: treeMorph model roots size = 2! !
